<template>
    <div class="ele-body">
        <a-card :bordered="false">
            <a-form
                :model="where"
                :wrapper-col="{ md: { span: 18 }, sm: { span: 24 } }"
            >
                <a-row>
                    <a-col :lg="6" :md="12" :sm="24" :xs="24">
                        <a-form-item label="年份:">
                            <a-select v-model:value="where.year" allow-clear show-search>
                                <a-select-option
                                    v-for="(item) in yearOptions"
                                    :key="item.value"
                                >{{ item.label }}
                                </a-select-option>
                            </a-select>
                        </a-form-item>
                    </a-col>
                    <a-col :lg="6" :md="12" :sm="24" :xs="24">
                        <a-space>
                            <a-button type="primary" @click="reload">查询</a-button>
                            <a-button @click="reset">重置</a-button>
                        </a-space>
                    </a-col>
                </a-row>
                <a-row>

                </a-row>
            </a-form>
            <a-modal
                v-model:visible="showNYear"
                :title="'批量复制'"
                :confirm-loading="loading"
                :body-style="{ paddingBottom: '8px' }"
                @ok="copyBatch"
            >
                <a-form
                    ref="form"
                    :model="form"
                    :rules="rules"
                    :label-col="{ md: { span: 6 }, sm: { span: 24 } }"
                    :wrapper-col="{ md: { span: 18 }, sm: { span: 24 } }"
                >
                    <a-form-item label="新年份" name="nYear">
                        <a-input-number id="inputNumber" v-model:value="nYear" :min="1970" :max="2050" />
                    </a-form-item>
                </a-form>
            </a-modal>
            <a-modal
                v-model:visible="showEdit"
                :title="form.id !== undefined ? '修改' : '添加'"
                :confirm-loading="loading"
                :width="500"
                :body-style="{ paddingBottom: '8px' }"
                @ok="save"
            >
                <a-form
                    ref="form"
                    :model="form"
                    :rules="rules"
                    :label-col="{ md: { span: 6 }, sm: { span: 24 } }"
                    :wrapper-col="{ md: { span: 18 }, sm: { span: 24 } }"
                >
                    <a-form-item label="年份" name="year">
                        <a-input-number  v-model:value="form.year" :min="1970" :max="2050" />
                    </a-form-item>
                    <a-form-item label="最小值" name="minLeq">
                        <a-input-number @change="minLeqChange" :step=".1" :precision="1" v-model:value="form.minLeq"  />
                    </a-form-item>
                    <a-form-item label="最大值" name="maxLeq">
                        <a-input-number :step=".1" :precision="1" v-model:value="form.maxLeq"  />
                    </a-form-item>
                    <a-form-item label="时段" name="timeSlot">
                        <a-select v-model:value="form.timeSlot">
                            <a-select-option value="昼">昼</a-select-option>
                            <a-select-option value="夜">夜</a-select-option>
                        </a-select>
                    </a-form-item>
                    <a-form-item label="等级" name="level">
                        <a-input
                            v-model:value="form.level"
                            placeholder="请输入等级"
                            allow-clear
                        />
                    </a-form-item>

                    <a-form-item label="评价" name="evaluate">
                        <a-input
                            v-model:value="form.evaluate"
                            placeholder="请输入评价"
                            allow-clear
                        />
                    </a-form-item>
                    <a-form-item label="排序" name="sortNumber">
                        <a-input-number :step="1" :precision="0" v-model:value="form.sortNumber"  />
                    </a-form-item>
                </a-form>
            </a-modal>
            <!-- 表格 -->
            <ele-pro-table
                v-model:selection="selectionList"
                ref="table"
                row-key="id"
                :datasource="url"
                :columns="columns"
                :where="where"
                :scroll="{ x: 'max-content' }"
                :need-page="false"
                @done="(d) => (data = d.data)"
            >
                <template #toolbar>
                    <a-space>
                        <a-button @click="openEdit" type="primary">新增</a-button>
                        <a-dropdown>
                            <template #overlay>
                                <a-menu @click="setCYear">
                                    <a-menu-item v-for="item in yearOptions" :key="item.value">
                                        {{ item.label }}
                                    </a-menu-item>
                                </a-menu>
                            </template>
                            <a-button>
                                批量复制
                                <DownOutlined/>
                            </a-button>
                        </a-dropdown>
                        <a-popconfirm
                            :disabled="selectionList.length == 0"
                            :title="`确认删除${selectionList.length}条数据吗?`"
                            ok-text="Yes"
                            cancel-text="No"
                            @confirm="removeBatch"
                        >
                            <a-button
                                :disabled="selectionList.length == 0"
                                type="primary"
                                ghost
                                danger
                            >删除
                            </a-button>
                        </a-popconfirm>
                        <a-button @click="exportData" type="primary">导出</a-button>
                    </a-space>
                </template>
                <template #action="{ record }">
                    <a-space>
                        <a-button
                            @click="openEdit(record)"
                            type="primary"
                            shape="round"
                            size="small"
                        >修改</a-button
                        >
                        <a-popconfirm
                            :title="`确认删除这条数据吗?`"
                            ok-text="Yes"
                            cancel-text="No"
                            @confirm="remove(record)"
                        >
                            <a-button type="primary" danger shape="round" size="small"
                            >删除</a-button
                            >
                        </a-popconfirm>
                    </a-space>
                </template>
            </ele-pro-table>
        </a-card>
    </div>
    <!-- 编辑弹窗 -->
</template>

<script>
// import _ from "lodash";
import {
    listAllUrl,
    saveLeqLevel,
    updateLeqLevel,
    removeLeqLevel,
    removeBatchLeqLevel,
    getColumnOptions,
    copyBatchLeqLevel
} from "@/api/ecology/noise/road-noise-leq-level";
import {DownOutlined} from '@ant-design/icons-vue';

import { message } from 'ant-design-vue';
import XLSX from "xlsx";
// import moment from "moment";

export default {
    name: "RoadNoiseLeqLevel",
    components: {DownOutlined},
    data() {
        return {
            data: [],
            // 表格数据接口
            url: listAllUrl,
            selection: [],
            // 表格列配置
            columns: [
                {
                    title: "年份",
                    dataIndex: "year",
                    sorter: true,
                },
                {
                    title: "时段",
                    dataIndex: "timeSlot",
                },
                {
                    title: "等级",
                    dataIndex: "level",
                },
                {
                    title: "最小值",
                    dataIndex: "minLeq",
                    customRender: ({text})=>{
                        return text!=undefined? text.toFixed(1):undefined
                    }
                },
                {
                    title: "最大值",
                    dataIndex: "maxLeq",
                    customRender: ({text})=>{
                        return text!=undefined? text.toFixed(1):undefined
                    }
                },
                {
                    title: "评价",
                    dataIndex: "evaluate",
                },
                {
                    title: "排序",
                    dataIndex: "sortNumber",
                },
                {
                    title: "操作",
                    key: "action",
                    width: 150,
                    align: "center",
                    fixed: "right",
                    slots: {
                        customRender: "action",
                    },
                },
            ],

            // 表格搜索条件
            where: {},
            // 表格选中数据
            selectionList: [],

            // 是否显示编辑弹窗
            showEdit: false,
            showNYear:false,
            cYear: undefined,
            nYear:undefined,
            yearOptions:[],
            // 表单数据
            form: {},
            loading: false,
            rules: {
                timeSlot:[{required: true,message: '请选择时段'}],
                // minLeq: [{required: true,message: '请输入最小值',},],
                // maxLeq: [{required: true,message: '请输入最大值',},],
                level: [{required: true,message: '请输入等级',},],
                // evaluate: [{required: true,message: '请输入评价',},],
                sortNumber: [{required: true,message: '请输入排序',},],
            },
        };
    },
    mounted() {
        this.getOptions()
    },
    methods: {
        minLeqChange(e){
            console.log(e)
        },
        /* 刷新表格 */
        reload() {

            this.$refs.table.reload({
                where: this.where,
            });
        },
        /* 重置搜索 */
        reset() {
            this.where = {};
            this.reload();
        },
        /* 打开编辑弹窗 */
        openEdit(row) {
            // cloneRecord.mi
            this.form = Object.assign({}, row);
            this.showEdit = true;
            this.$nextTick(() => {
                this.$refs.form.clearValidate(); // 清除表单验证信息
            });
        },
        async save() {
            await this.$refs.form.validate();
            const {minLeq,maxLeq }  = this.form;
            if(minLeq == undefined && maxLeq == undefined ){
                message.error("最小值和最大值请至少填写一项！")
                return;
            }
            const hide = this.$message.loading('请求中..', 0);
            const form = this.form;
            if (form.id) {
                updateLeqLevel(form)
                    .then((res) => {
                        if (res.data.code == 0) {
                            this.showEdit = false;
                            this.$message.success(res.data.msg);
                            this.reload();
                            this.getOptions()
                        } else {
                            this.$message.error(res.data.msg);
                        }
                    })
                    .catch((error) => {
                        this.$message.error(error.message);
                    })
                    .finally(() => {
                        hide();
                    });
            } else {
                saveLeqLevel(form)
                    .then((res) => {
                        if (res.data.code == 0) {
                            this.showEdit = false;
                            this.$message.success(res.data.msg);
                            this.reload();
                            this.getOptions()
                        } else {
                            this.$message.error(res.data.msg);
                        }
                    })
                    .catch((error) => {
                        this.$message.error(error.message);
                    })
                    .finally(() => {
                        hide();
                    });
            }
        },
        /* 删除单个 */
        remove(row) {
            const hide = this.$message.loading('请求中..', 0);
            removeLeqLevel(row.id).then((res) => {
                hide();
                if (res.data.code === 0) {
                    this.$message.success(res.data.msg);
                    this.reload();
                } else {
                    this.$message.error(res.data.msg);
                }
            }).catch(e => {
                hide();
                this.$message.error(e.message);
            })
        },
        /* 批量删除 */
        removeBatch() {
            const hide = this.$message.loading('请求中..', 0);
            const ids = this.selectionList.map((item) => item.id);
            removeBatchLeqLevel(ids).then((res) => {
                if (res.data.code === 0) {
                    this.$message.success(res.data.msg);
                    this.reload();
                } else {
                    this.$message.error(res.data.msg);
                }
            }).catch(e => {
                this.$message.error(e.message);
            }).finally(() => {
                hide();
            })
        },
        getOptions(){
            getColumnOptions("year").then(res => {
                console.log(res)
                if (res.data.code == 0) {
                    this.yearOptions = res.data.data.map(item => {
                        return {
                            label: item,
                            value: item
                        }
                    })
                }
            })
        },
        setCYear(e){
            this.cYear = e.key;
            this.showNYear = true;
        },
        copyBatch(){
            const hide = this.$message.loading('请求中..', 0);
            copyBatchLeqLevel({cyear:Number(this.cYear),nyear:this.nYear}).then(res=>{
                if (res.data.code === 0) {
                    this.$message.success(res.data.msg);
                    this.reload();
                    this.getOptions();
                } else {
                    this.$message.error(res.data.msg);
                }
                this.showNYear = false;
            }).catch(e => {
                this.$message.error(e.message);
            }).finally(() => {
                hide();
            })
        },
        exportData(){
            const columns = this.columns.filter(item=>item.dataIndex);
            const arr = [];
            const th = columns.map((item) => item.title);
            arr.push(th);
            this.data.forEach((d) => {
                const td = columns.map((item) => d[item.dataIndex]);
                arr.push(td);
            });

            let sheet = XLSX.utils.aoa_to_sheet(arr);
            this.$util.exportSheet(XLSX, sheet, new Date().getTime().toString());
        }


    },
};
</script>

<style scoped lang="less">
</style>